package com.neusoft.smart.pos.advertisement.persistent.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class MediaStrategyExample {

	protected String orderByClause;

	protected boolean distinct;

	protected List<Criteria> oredCriteria;

	private Integer offset;

	private Integer limit;

	public MediaStrategyExample() {
		oredCriteria = new ArrayList<Criteria>();
	}

	public String getOrderByClause() {
		return orderByClause;
	}

	public void setOrderByClause(String orderByClause) {
		this.orderByClause = orderByClause;
	}

	public boolean isDistinct() {
		return distinct;
	}

	public void setDistinct(boolean distinct) {
		this.distinct = distinct;
	}

	public List<Criteria> getOredCriteria() {
		return oredCriteria;
	}

	public void or(Criteria criteria) {
		oredCriteria.add(criteria);
	}

	public Criteria or() {
		Criteria criteria = createCriteriaInternal();
		oredCriteria.add(criteria);
		return criteria;
	}

	public Criteria createCriteria() {
		Criteria criteria = createCriteriaInternal();
		if (oredCriteria.size() == 0) {
			oredCriteria.add(criteria);
		}
		return criteria;
	}

	protected Criteria createCriteriaInternal() {
		Criteria criteria = new Criteria();
		return criteria;
	}

	public void clear() {
		oredCriteria.clear();
		orderByClause = null;
		distinct = false;
		this.offset = null;
		this.limit = null;
	}

	public Integer getOffset() {
		return this.offset;
	}

	public void setOffset(Integer offset) {
		this.offset = offset;
	}

	public Integer getLimit() {
		return this.limit;
	}

	public void setLimit(Integer limit) {
		this.limit = limit;
	}

	public MediaStrategyExample page(int offset, int limit) {
		this.offset = offset;
		this.limit = limit;
		return this;
	}

	protected abstract static class GeneratedCriteria {

		protected List<Criterion> criteria;

		protected GeneratedCriteria() {
			super();
			criteria = new ArrayList<Criterion>();
		}

		public boolean isValid() {
			return criteria.size() > 0;
		}

		public List<Criterion> getAllCriteria() {
			return criteria;
		}

		public List<Criterion> getCriteria() {
			return criteria;
		}

		protected void addCriterion(String condition) {
			if (condition == null) {
				throw new RuntimeException("Value for condition cannot be null");
			}
			criteria.add(new Criterion(condition));
		}

		protected void addCriterion(String condition, Object value, String property) {
			if (value == null) {
				throw new RuntimeException("Value for " + property + " cannot be null");
			}
			criteria.add(new Criterion(condition, value));
		}

		protected void addCriterion(String condition, Object value1, Object value2, String property) {
			if (value1 == null || value2 == null) {
				throw new RuntimeException("Between values for " + property + " cannot be null");
			}
			criteria.add(new Criterion(condition, value1, value2));
		}

		protected void addCriterionForJDBCTime(String condition, Date value, String property) {
			if (value == null) {
				throw new RuntimeException("Value for " + property + " cannot be null");
			}
			addCriterion(condition, new java.sql.Time(value.getTime()), property);
		}

		protected void addCriterionForJDBCTime(String condition, List<Date> values, String property) {
			if (values == null || values.size() == 0) {
				throw new RuntimeException("Value list for " + property + " cannot be null or empty");
			}
			List<java.sql.Time> timeList = new ArrayList<java.sql.Time>();
			Iterator<Date> iter = values.iterator();
			while (iter.hasNext()) {
				timeList.add(new java.sql.Time(iter.next().getTime()));
			}
			addCriterion(condition, timeList, property);
		}

		protected void addCriterionForJDBCTime(String condition, Date value1, Date value2, String property) {
			if (value1 == null || value2 == null) {
				throw new RuntimeException("Between values for " + property + " cannot be null");
			}
			addCriterion(condition, new java.sql.Time(value1.getTime()), new java.sql.Time(value2.getTime()), property);
		}

		public Criteria andIdIsNull() {
			addCriterion("id is null");
			return (Criteria) this;
		}

		public Criteria andIdIsNotNull() {
			addCriterion("id is not null");
			return (Criteria) this;
		}

		public Criteria andIdEqualTo(Integer value) {
			addCriterion("id =", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdNotEqualTo(Integer value) {
			addCriterion("id <>", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdGreaterThan(Integer value) {
			addCriterion("id >", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdGreaterThanOrEqualTo(Integer value) {
			addCriterion("id >=", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdLessThan(Integer value) {
			addCriterion("id <", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdLessThanOrEqualTo(Integer value) {
			addCriterion("id <=", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdIn(List<Integer> values) {
			addCriterion("id in", values, "id");
			return (Criteria) this;
		}

		public Criteria andIdNotIn(List<Integer> values) {
			addCriterion("id not in", values, "id");
			return (Criteria) this;
		}

		public Criteria andIdBetween(Integer value1, Integer value2) {
			addCriterion("id between", value1, value2, "id");
			return (Criteria) this;
		}

		public Criteria andIdNotBetween(Integer value1, Integer value2) {
			addCriterion("id not between", value1, value2, "id");
			return (Criteria) this;
		}

		public Criteria andStrategyIdIsNull() {
			addCriterion("strategy_id is null");
			return (Criteria) this;
		}

		public Criteria andStrategyIdIsNotNull() {
			addCriterion("strategy_id is not null");
			return (Criteria) this;
		}

		public Criteria andStrategyIdEqualTo(Integer value) {
			addCriterion("strategy_id =", value, "strategyId");
			return (Criteria) this;
		}

		public Criteria andStrategyIdNotEqualTo(Integer value) {
			addCriterion("strategy_id <>", value, "strategyId");
			return (Criteria) this;
		}

		public Criteria andStrategyIdGreaterThan(Integer value) {
			addCriterion("strategy_id >", value, "strategyId");
			return (Criteria) this;
		}

		public Criteria andStrategyIdGreaterThanOrEqualTo(Integer value) {
			addCriterion("strategy_id >=", value, "strategyId");
			return (Criteria) this;
		}

		public Criteria andStrategyIdLessThan(Integer value) {
			addCriterion("strategy_id <", value, "strategyId");
			return (Criteria) this;
		}

		public Criteria andStrategyIdLessThanOrEqualTo(Integer value) {
			addCriterion("strategy_id <=", value, "strategyId");
			return (Criteria) this;
		}

		public Criteria andStrategyIdIn(List<Integer> values) {
			addCriterion("strategy_id in", values, "strategyId");
			return (Criteria) this;
		}

		public Criteria andStrategyIdNotIn(List<Integer> values) {
			addCriterion("strategy_id not in", values, "strategyId");
			return (Criteria) this;
		}

		public Criteria andStrategyIdBetween(Integer value1, Integer value2) {
			addCriterion("strategy_id between", value1, value2, "strategyId");
			return (Criteria) this;
		}

		public Criteria andStrategyIdNotBetween(Integer value1, Integer value2) {
			addCriterion("strategy_id not between", value1, value2, "strategyId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdIsNull() {
			addCriterion("device_id is null");
			return (Criteria) this;
		}

		public Criteria andDeviceIdIsNotNull() {
			addCriterion("device_id is not null");
			return (Criteria) this;
		}

		public Criteria andDeviceIdEqualTo(Integer value) {
			addCriterion("device_id =", value, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdNotEqualTo(Integer value) {
			addCriterion("device_id <>", value, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdGreaterThan(Integer value) {
			addCriterion("device_id >", value, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdGreaterThanOrEqualTo(Integer value) {
			addCriterion("device_id >=", value, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdLessThan(Integer value) {
			addCriterion("device_id <", value, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdLessThanOrEqualTo(Integer value) {
			addCriterion("device_id <=", value, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdIn(List<Integer> values) {
			addCriterion("device_id in", values, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdNotIn(List<Integer> values) {
			addCriterion("device_id not in", values, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdBetween(Integer value1, Integer value2) {
			addCriterion("device_id between", value1, value2, "deviceId");
			return (Criteria) this;
		}

		public Criteria andDeviceIdNotBetween(Integer value1, Integer value2) {
			addCriterion("device_id not between", value1, value2, "deviceId");
			return (Criteria) this;
		}

		public Criteria andMediaResourceIdIsNull() {
			addCriterion("media_resource_id is null");
			return (Criteria) this;
		}

		public Criteria andMediaResourceIdIsNotNull() {
			addCriterion("media_resource_id is not null");
			return (Criteria) this;
		}

		public Criteria andMediaResourceIdEqualTo(Integer value) {
			addCriterion("media_resource_id =", value, "mediaResourceId");
			return (Criteria) this;
		}

		public Criteria andMediaResourceIdNotEqualTo(Integer value) {
			addCriterion("media_resource_id <>", value, "mediaResourceId");
			return (Criteria) this;
		}

		public Criteria andMediaResourceIdGreaterThan(Integer value) {
			addCriterion("media_resource_id >", value, "mediaResourceId");
			return (Criteria) this;
		}

		public Criteria andMediaResourceIdGreaterThanOrEqualTo(Integer value) {
			addCriterion("media_resource_id >=", value, "mediaResourceId");
			return (Criteria) this;
		}

		public Criteria andMediaResourceIdLessThan(Integer value) {
			addCriterion("media_resource_id <", value, "mediaResourceId");
			return (Criteria) this;
		}

		public Criteria andMediaResourceIdLessThanOrEqualTo(Integer value) {
			addCriterion("media_resource_id <=", value, "mediaResourceId");
			return (Criteria) this;
		}

		public Criteria andMediaResourceIdIn(List<Integer> values) {
			addCriterion("media_resource_id in", values, "mediaResourceId");
			return (Criteria) this;
		}

		public Criteria andMediaResourceIdNotIn(List<Integer> values) {
			addCriterion("media_resource_id not in", values, "mediaResourceId");
			return (Criteria) this;
		}

		public Criteria andMediaResourceIdBetween(Integer value1, Integer value2) {
			addCriterion("media_resource_id between", value1, value2, "mediaResourceId");
			return (Criteria) this;
		}

		public Criteria andMediaResourceIdNotBetween(Integer value1, Integer value2) {
			addCriterion("media_resource_id not between", value1, value2, "mediaResourceId");
			return (Criteria) this;
		}

		public Criteria andPlayLengthIsNull() {
			addCriterion("play_length is null");
			return (Criteria) this;
		}

		public Criteria andPlayLengthIsNotNull() {
			addCriterion("play_length is not null");
			return (Criteria) this;
		}

		public Criteria andPlayLengthEqualTo(Integer value) {
			addCriterion("play_length =", value, "playLength");
			return (Criteria) this;
		}

		public Criteria andPlayLengthNotEqualTo(Integer value) {
			addCriterion("play_length <>", value, "playLength");
			return (Criteria) this;
		}

		public Criteria andPlayLengthGreaterThan(Integer value) {
			addCriterion("play_length >", value, "playLength");
			return (Criteria) this;
		}

		public Criteria andPlayLengthGreaterThanOrEqualTo(Integer value) {
			addCriterion("play_length >=", value, "playLength");
			return (Criteria) this;
		}

		public Criteria andPlayLengthLessThan(Integer value) {
			addCriterion("play_length <", value, "playLength");
			return (Criteria) this;
		}

		public Criteria andPlayLengthLessThanOrEqualTo(Integer value) {
			addCriterion("play_length <=", value, "playLength");
			return (Criteria) this;
		}

		public Criteria andPlayLengthIn(List<Integer> values) {
			addCriterion("play_length in", values, "playLength");
			return (Criteria) this;
		}

		public Criteria andPlayLengthNotIn(List<Integer> values) {
			addCriterion("play_length not in", values, "playLength");
			return (Criteria) this;
		}

		public Criteria andPlayLengthBetween(Integer value1, Integer value2) {
			addCriterion("play_length between", value1, value2, "playLength");
			return (Criteria) this;
		}

		public Criteria andPlayLengthNotBetween(Integer value1, Integer value2) {
			addCriterion("play_length not between", value1, value2, "playLength");
			return (Criteria) this;
		}

		public Criteria andShowTimeBeginIsNull() {
			addCriterion("show_time_begin is null");
			return (Criteria) this;
		}

		public Criteria andShowTimeBeginIsNotNull() {
			addCriterion("show_time_begin is not null");
			return (Criteria) this;
		}

		public Criteria andShowTimeBeginEqualTo(Date value) {
			addCriterionForJDBCTime("show_time_begin =", value, "showTimeBegin");
			return (Criteria) this;
		}

		public Criteria andShowTimeBeginNotEqualTo(Date value) {
			addCriterionForJDBCTime("show_time_begin <>", value, "showTimeBegin");
			return (Criteria) this;
		}

		public Criteria andShowTimeBeginGreaterThan(Date value) {
			addCriterionForJDBCTime("show_time_begin >", value, "showTimeBegin");
			return (Criteria) this;
		}

		public Criteria andShowTimeBeginGreaterThanOrEqualTo(Date value) {
			addCriterionForJDBCTime("show_time_begin >=", value, "showTimeBegin");
			return (Criteria) this;
		}

		public Criteria andShowTimeBeginLessThan(Date value) {
			addCriterionForJDBCTime("show_time_begin <", value, "showTimeBegin");
			return (Criteria) this;
		}

		public Criteria andShowTimeBeginLessThanOrEqualTo(Date value) {
			addCriterionForJDBCTime("show_time_begin <=", value, "showTimeBegin");
			return (Criteria) this;
		}

		public Criteria andShowTimeBeginIn(List<Date> values) {
			addCriterionForJDBCTime("show_time_begin in", values, "showTimeBegin");
			return (Criteria) this;
		}

		public Criteria andShowTimeBeginNotIn(List<Date> values) {
			addCriterionForJDBCTime("show_time_begin not in", values, "showTimeBegin");
			return (Criteria) this;
		}

		public Criteria andShowTimeBeginBetween(Date value1, Date value2) {
			addCriterionForJDBCTime("show_time_begin between", value1, value2, "showTimeBegin");
			return (Criteria) this;
		}

		public Criteria andShowTimeBeginNotBetween(Date value1, Date value2) {
			addCriterionForJDBCTime("show_time_begin not between", value1, value2, "showTimeBegin");
			return (Criteria) this;
		}

		public Criteria andShowTimeEndIsNull() {
			addCriterion("show_time_end is null");
			return (Criteria) this;
		}

		public Criteria andShowTimeEndIsNotNull() {
			addCriterion("show_time_end is not null");
			return (Criteria) this;
		}

		public Criteria andShowTimeEndEqualTo(Date value) {
			addCriterionForJDBCTime("show_time_end =", value, "showTimeEnd");
			return (Criteria) this;
		}

		public Criteria andShowTimeEndNotEqualTo(Date value) {
			addCriterionForJDBCTime("show_time_end <>", value, "showTimeEnd");
			return (Criteria) this;
		}

		public Criteria andShowTimeEndGreaterThan(Date value) {
			addCriterionForJDBCTime("show_time_end >", value, "showTimeEnd");
			return (Criteria) this;
		}

		public Criteria andShowTimeEndGreaterThanOrEqualTo(Date value) {
			addCriterionForJDBCTime("show_time_end >=", value, "showTimeEnd");
			return (Criteria) this;
		}

		public Criteria andShowTimeEndLessThan(Date value) {
			addCriterionForJDBCTime("show_time_end <", value, "showTimeEnd");
			return (Criteria) this;
		}

		public Criteria andShowTimeEndLessThanOrEqualTo(Date value) {
			addCriterionForJDBCTime("show_time_end <=", value, "showTimeEnd");
			return (Criteria) this;
		}

		public Criteria andShowTimeEndIn(List<Date> values) {
			addCriterionForJDBCTime("show_time_end in", values, "showTimeEnd");
			return (Criteria) this;
		}

		public Criteria andShowTimeEndNotIn(List<Date> values) {
			addCriterionForJDBCTime("show_time_end not in", values, "showTimeEnd");
			return (Criteria) this;
		}

		public Criteria andShowTimeEndBetween(Date value1, Date value2) {
			addCriterionForJDBCTime("show_time_end between", value1, value2, "showTimeEnd");
			return (Criteria) this;
		}

		public Criteria andShowTimeEndNotBetween(Date value1, Date value2) {
			addCriterionForJDBCTime("show_time_end not between", value1, value2, "showTimeEnd");
			return (Criteria) this;
		}

		public Criteria andBackgroundAudioIdIsNull() {
			addCriterion("background_audio_id is null");
			return (Criteria) this;
		}

		public Criteria andBackgroundAudioIdIsNotNull() {
			addCriterion("background_audio_id is not null");
			return (Criteria) this;
		}

		public Criteria andBackgroundAudioIdEqualTo(Integer value) {
			addCriterion("background_audio_id =", value, "backgroundAudioId");
			return (Criteria) this;
		}

		public Criteria andBackgroundAudioIdNotEqualTo(Integer value) {
			addCriterion("background_audio_id <>", value, "backgroundAudioId");
			return (Criteria) this;
		}

		public Criteria andBackgroundAudioIdGreaterThan(Integer value) {
			addCriterion("background_audio_id >", value, "backgroundAudioId");
			return (Criteria) this;
		}

		public Criteria andBackgroundAudioIdGreaterThanOrEqualTo(Integer value) {
			addCriterion("background_audio_id >=", value, "backgroundAudioId");
			return (Criteria) this;
		}

		public Criteria andBackgroundAudioIdLessThan(Integer value) {
			addCriterion("background_audio_id <", value, "backgroundAudioId");
			return (Criteria) this;
		}

		public Criteria andBackgroundAudioIdLessThanOrEqualTo(Integer value) {
			addCriterion("background_audio_id <=", value, "backgroundAudioId");
			return (Criteria) this;
		}

		public Criteria andBackgroundAudioIdIn(List<Integer> values) {
			addCriterion("background_audio_id in", values, "backgroundAudioId");
			return (Criteria) this;
		}

		public Criteria andBackgroundAudioIdNotIn(List<Integer> values) {
			addCriterion("background_audio_id not in", values, "backgroundAudioId");
			return (Criteria) this;
		}

		public Criteria andBackgroundAudioIdBetween(Integer value1, Integer value2) {
			addCriterion("background_audio_id between", value1, value2, "backgroundAudioId");
			return (Criteria) this;
		}

		public Criteria andBackgroundAudioIdNotBetween(Integer value1, Integer value2) {
			addCriterion("background_audio_id not between", value1, value2, "backgroundAudioId");
			return (Criteria) this;
		}

		public Criteria andStatusIsNull() {
			addCriterion("status is null");
			return (Criteria) this;
		}

		public Criteria andStatusIsNotNull() {
			addCriterion("status is not null");
			return (Criteria) this;
		}

		public Criteria andStatusEqualTo(Integer value) {
			addCriterion("status =", value, "status");
			return (Criteria) this;
		}

		public Criteria andStatusNotEqualTo(Integer value) {
			addCriterion("status <>", value, "status");
			return (Criteria) this;
		}

		public Criteria andStatusGreaterThan(Integer value) {
			addCriterion("status >", value, "status");
			return (Criteria) this;
		}

		public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
			addCriterion("status >=", value, "status");
			return (Criteria) this;
		}

		public Criteria andStatusLessThan(Integer value) {
			addCriterion("status <", value, "status");
			return (Criteria) this;
		}

		public Criteria andStatusLessThanOrEqualTo(Integer value) {
			addCriterion("status <=", value, "status");
			return (Criteria) this;
		}

		public Criteria andStatusIn(List<Integer> values) {
			addCriterion("status in", values, "status");
			return (Criteria) this;
		}

		public Criteria andStatusNotIn(List<Integer> values) {
			addCriterion("status not in", values, "status");
			return (Criteria) this;
		}

		public Criteria andStatusBetween(Integer value1, Integer value2) {
			addCriterion("status between", value1, value2, "status");
			return (Criteria) this;
		}

		public Criteria andStatusNotBetween(Integer value1, Integer value2) {
			addCriterion("status not between", value1, value2, "status");
			return (Criteria) this;
		}
	}

	public static class Criteria extends GeneratedCriteria {

		protected Criteria() {
			super();
		}
	}

	public static class Criterion {

		private String condition;

		private Object value;

		private Object secondValue;

		private boolean noValue;

		private boolean singleValue;

		private boolean betweenValue;

		private boolean listValue;

		private String typeHandler;

		protected Criterion(String condition) {
			super();
			this.condition = condition;
			this.typeHandler = null;
			this.noValue = true;
		}

		protected Criterion(String condition, Object value, String typeHandler) {
			super();
			this.condition = condition;
			this.value = value;
			this.typeHandler = typeHandler;
			if (value instanceof List<?>) {
				this.listValue = true;
			} else {
				this.singleValue = true;
			}
		}

		protected Criterion(String condition, Object value) {
			this(condition, value, null);
		}

		protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
			super();
			this.condition = condition;
			this.value = value;
			this.secondValue = secondValue;
			this.typeHandler = typeHandler;
			this.betweenValue = true;
		}

		protected Criterion(String condition, Object value, Object secondValue) {
			this(condition, value, secondValue, null);
		}

		public String getCondition() {
			return condition;
		}

		public Object getValue() {
			return value;
		}

		public Object getSecondValue() {
			return secondValue;
		}

		public boolean isNoValue() {
			return noValue;
		}

		public boolean isSingleValue() {
			return singleValue;
		}

		public boolean isBetweenValue() {
			return betweenValue;
		}

		public boolean isListValue() {
			return listValue;
		}

		public String getTypeHandler() {
			return typeHandler;
		}
	}
}